// PwdHashDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PwdHash.h"
#include "PwdHashDlg.h"
#include "HashedPassword.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPwdHashDlg dialog




CPwdHashDlg::CPwdHashDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPwdHashDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPwdHashDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPwdHashDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CPwdHashDlg::OnBnClickedOk)
	ON_EN_SETFOCUS(IDC_EDIT_URL, &CPwdHashDlg::OnEnSetfocusEditUrl)
	ON_EN_SETFOCUS(IDC_EDIT_PW, &CPwdHashDlg::OnEnSetfocusEditPw)
END_MESSAGE_MAP()


// CPwdHashDlg message handlers

BOOL CPwdHashDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	((CEdit*)GetDlgItem(IDC_EDIT_URL))->SetFocus();

	return FALSE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPwdHashDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPwdHashDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CPwdHashDlg::OnBnClickedOk()
{
	// Get UI data
	CEdit* pEdit = (CEdit*)GetDlgItem(IDC_EDIT_URL);
	char szUrl[1024] = {0};
	pEdit->GetWindowText(szUrl, sizeof(szUrl));
	if (strlen(szUrl) == 0)
		return;
	pEdit = (CEdit*)GetDlgItem(IDC_EDIT_PW);
	char szPassword[1024] = {0};
	pEdit->GetWindowText(szPassword, sizeof(szPassword));
	if (strlen(szPassword) > 21)
	{
		AfxMessageBox("This program cannot hash password longer than 21 characters.");
		return;
	}

	// Generate Hashed Password
	string strHshPwd = HashedPassword::getHashedPassword(szPassword, HashedPassword::ExtractDomain(szUrl).c_str());
	
	// Copy to Clipboard
	if (OpenClipboard() != TRUE)
	{
		AfxMessageBox("Error: OpenClipboard");
		return;
	}
	EmptyClipboard();
	HGLOBAL hglbCopy;
	int nCopyLen = strHshPwd.length();
	hglbCopy = GlobalAlloc(GMEM_MOVEABLE, nCopyLen + 1);
	if (hglbCopy == NULL)
	{
		CloseClipboard();
		AfxMessageBox("Error: GlobalAlloc");
		return;
	}
	void* pCopy = GlobalLock(hglbCopy);
	memcpy(pCopy, strHshPwd.c_str(), nCopyLen);
	memset((char*)pCopy + nCopyLen, 0, 1);
	GlobalUnlock(hglbCopy);
	SetClipboardData(CF_TEXT, hglbCopy);
	CloseClipboard();

	// Show Status
	((CStatic*)GetDlgItem(IDC_STATIC_STATUS))->SetWindowText("Hashed Password copied to clipboard.");
	//((CStatic*)GetDlgItem(IDC_STATIC_STATUS))->SetWindowText(strHshPwd.c_str());
}

void CPwdHashDlg::OnEnSetfocusEditUrl()
{
	((CStatic*)GetDlgItem(IDC_STATIC_STATUS))->SetWindowText("");
}

void CPwdHashDlg::OnEnSetfocusEditPw()
{
	((CStatic*)GetDlgItem(IDC_STATIC_STATUS))->SetWindowText("");
}
